#Include 'Protheus.ch'

//Inicio funo principal
User Function  xModelo2()
    
    Private cCadastro:="Prototipo Modelo 2"
    Private aRotina:= { }
    
    
    AADD( aRotina,{"Pesquisar"  ," AxPesqui"     ,0,1})
    AADD( aRotina,{"Visualizar" ,"U_Manutencao" ,0,2})
    AADD( aRotina,{"Incluir"    ,"U_Inclusao"   ,0,3})
    AADD( aRotina,{"Alterar"    ,"U_Manutencao" ,0,4})
    AADD( aRotina,{"Excluir"    ,"U_Manutencao" ,0,5})
    
    dbSelectArea("ZA3")
    dbSetOrder(1)
    dbGoTop( )
        
    MBrowse(,  ,  ,  , "ZA3")
    
Return
//Fim funo principal

//Inicio da rotina de incluso de dados
User Function Inclusao( cAlias, nReg, nOpc)//recebe trs parametros
    
    Local oDlg
    Local oGet
    Local oTPanel1
    Local oTPanel2
    
    Local cCodigo :=  ZA3->ZA3_CODIGO
    Local cNome      := ZA3->ZA3_NOME
    Local dData      := dDataBase
    
    Private aHeader:= {}
    Private aCOLS    :=  {}
    Private aREG       :=  {}
    
    dbSelectArea(cAlias)
    dbSetOrder(1)
    
    Mod2aHeader(cAlias)
    Mod2aCOLS(cAlias, nReg, nOpc)
    
    DEFINE MSDIALOG  oDlg TITLE cCadastro From 8,0 To 28,80 OF oMainWnd
    
    //oTPanel1 := TPanel( ) :New (0,0 " ",oDlg,NIL, .T.,.F. ,NIL,NIL,0,16,.T.,.F.)
     oTPanel1 := TPanel( ) :New(0,0," ",oDlg,NIL,.T.,.F.,NIL,NIL,0,16,.T.,.F.)
    
    oTPanel1 := Align  :=  CONTROL_ALIGN_TOP
    
    @ 4, 006  SAY  "Cdigo:"   SIZE 70,7  PIXEL OF  oTPanel1
    @ 4, 062  SAY  "Nome: "    SIZE 70,7  PIXEL OF  oTPanel1
    @ 4, 166  SAY  "Emissao:"  SIZE 70,7  PIXEL OF  oTPanel1
    
    @ 3, 026 MSGET cCodigo F3  "SA3"  PICTURE  "@!"  VALID  Mod2Vend (cCodigo, @Nome) SIZE 030,7 PIXEL OF  oTPanel1
    
    oTPanel2 := TPanel ( ) :New(0,0," ", oDlg,NIL,.T., .F.,NIL,NIL,0,16,.T.,.F.)
    oTPanel2 := Align := CONTROL_ALIGN_BOTTOM
    
    oGet := MSGetDados(): New (0,0,0,0, nOpc,"U_Mod2LOk()", ".T.", "+ZA3_ITEM",.T.)
    
    oGet: oBrowse:Align := CONTROL_ALIGN_ALLCLIENT
    
   ACTIVATE  MSDIALOG oDlg  CENTER ON INIT;
        EnchoiceBar ( oDlg, {|| IIF (U_Mod2TOk ( ), Mod2GrvI(),;
        	 ( oDlg: End(), NIL ) ) },  {|| oDlg: End () } )     
Return
//Fim da rotina de incluso


//Inicio da rotina de manuteno
User Function  Manutencao (cAlias, nReg, nOpc )
    
    Local  oDlg
    Local  oGet
    Local  oTPanel1
    Local  oTPanel2
    
    Local  cCodigo :=  Space(Len (Space (ZA3->ZA3_CODIGO)))
    Local  cNome   :=  Space (Len (Space (ZA3->ZA3_NOME)))
    Local  dData  :=   Ctod (Space (8))
    
    Private  aHeader:= {}
    Private  aCOLS      := {}
    Private  aREG         := {}
    
    dbSelectArea(cAlias)
    dbSetOrder(1)
    
    cCodigo    := ZA3->ZA3_CODIGO
    cNome      := ZA3->ZA3_NOME
    cData       := ZA3->ZA3_DATA
    
    Mod2aHeader(cAlias)
    Mod2aCOLS (cAlias,   nReg,  nOpc  )
    
    DEFINE MSDIALOG  oDlg  TITLE  cCadastro From 8,0 To  28,80  OF oMainWnd
    
            oTPanel1 :=  TPanel(): New( 0,0," ",oDlg, NIL , .T., .F.,NIL,NIL,0,16,.T.,.F.)
    
            oTPanel1 := Align  :=  CONTROL_ALIGN_TOP
    
    @ 4, 006  SAY  "Cdigo:"   SIZE 70,7  PIXEL OF  oTPanel1
    @ 4, 062  SAY  "Nome: "    SIZE 70,7  PIXEL OF  oTPanel1
    @ 4, 166  SAY  "Emissao:"  SIZE 70,7  PIXEL OF  oTPanel1
    
    @ 3, 026  MSGET cCodigo When .F. SIZE 30,7 PIXEL OF  oTPanel1
    @ 3, 080  MSGET cNome   When .F. SIZE 78,7 PIXEL OF  oTPanel1
    @ 3, 192  MSGET dData   When .F. SIZE 40,7 PIXEL OF  oTPanel1
    
    oTPanel2 := TPanel():New (0,0,"",oDlg,NIL,.T.,;
        .F.,NIL,NIL,0,16,.T.,.F.)
    oTPanel2 := Align := CONTROL_ALING_BOTTOM
    
    If(nOpc == 4)
        oGet:= MSGetDados():New (0,0,nOpc, "U_Mod2LOk()", ".T.","+ZA3_ITEM",.T.)
    Else
        oGet := MSGetDados():New (0,0,0, nOpc)
    EndIf
    oGet: oBrowse: Align := CONTROL_ALIGN_ALLCLIENT
    
    ACTIVATE MSDIALOG oDlg CENTER ON INIT;
        EnchoiceBar ( oDlg, { ||  (IIF ( nOpc == 4, Mod2GrvA( ),;
        	 IIF(nOpc == 5, Mod2GrvE(), oDlg: End() ) ), oDlg: End( )  )  }, ;
        	       { ||  oDlg : End ( ) }  )
                       
    
Return
//Fim da rotina de manuteno

Static Function  Mod2aHeader(cAlias)
    Local aArea:= GetArea()
    
    
    dbSelectArea("SX3")
    dbSetOrder(1)
    dbSeek(cAlias)
    While ! EOF() .And. X3_ARQUIVO == cAlias
        If X3Uso(X3_USADO) .And. cNivel >= X3_NIVEl
            aadd( aHeader,  { Trim (X3Titulo ( ) ),;
            	X3_CAMPO,;
            	X3_PICTURE,;
            	X3_TAMANHO,;
            	X3_DECIMAL,;
            	X3_VALID,;
            	X3_USADO,;
            	X3_TIPO,;
            	X3_ARQUIVO,;
            	X3_CONTEXT  } )
        Endif
        dbSkip()
    End
    RestArea(aArea)
Return

// Montagem das colunas com o Array aCOLS
Static Function Mod2aCOLS(cAlias, nReg, nOpc)
    Local  aArea:= GetArea()
    Local nChave:= ZA3->ZA3_CODIGO
    Local nI:= 0
    
    If nOpc <> 3
        dbSelectArea(cAlias)
        dbSetOrder(1)
        dbSeek( xFilial (cAlias) + cChave)
        While ! EOF( ) .And.  ZA3->(ZA3_FILIAL +ZA3_CODIGO ) == xFILIAL (cAlias) + cChave
            aadd( aReg, ZA3->(RecNo( )  ) )
            aadd( aCOLS, Array( Len ( aHeader ) + 1  ) )
            
            For nI := 1 to Len (aHeader)
                If aHeader [ nI,10] == "V"
                    aCOLS [ Len (aCOLS), nI ] := CriarVar(aHeader [nI,2 ], .T.)
                Else
                    aCOLS [ Len( aCOLS), nI]
                    FieldGet (FieldPos (aHeader [ nI, 2] ) )
                EndIf
                
            Next nI
            aCOLS  [ Len (aCOLS), Len (aHeader) + 1 ] := .F.
            dbSkip()
            
        End
    Else
        aadd( aCOLS, Array ( Len ( aHeader ) + 1 )  )
        For nI := 1 to Len ( aHeader )
            aCOLS [ 1, nI ] := CriarVar( aHeader [nI, 2], .T. )
        Next nI
        aCOLS[1, GdFieldPos ("ZA3_ITEM") ] :=  "01"
        aCOLS[1, Len (  aHeader  ) + 1 ] := .F.
    EndIf
    RestArea( aArea )
Return


//|| Rotina | ModGrvI||
//|| Para grava os dados de incluso
Static Function ModGrvI ( )
    Local aArea := GetArea( )
    Local nI := 0
    Local nX := 0
    
    dbSelectArea("ZA3")
    dbSetOrder ( 1 )
    For nI := 1 to Len ( aCOLS )
        If ! aCOLS [ nI, Len ( aHeader) + 1 ]
            RecLock( "ZA3", .T. )
            ZA3->ZA3_FILIAL := xFilial ("ZA3" )
            ZA3->ZA3_CODIGO := cCodigo
            ZA3->ZA3_DATA :=  dData
            For nX := 1  to Len ( aHeader )
                FieldPut ( FieldPos ( aHeader  [nX, 2] ), aCOLS[nI, nX] )
            Next nX
            MsUnlock( )
        EndIf
    Next nI
    
    RestArea ( aArea )
    
Return

//|| Rotina | ModGrvI||
//|| Para  de alterao
Static Function  Mod2GrvA( )
    Local aArea:= GetArea( )
    Local nI := 0
    Local nX := 0

dbSelectArea("ZA3" )
For nI := 1 to Len ( aReg )
    If nI <= Len ( aReg )
        dbGotop( aReg[nI] )
        RecLock("ZA3", .F.)
        if( aCOLS [ nI, Len ( aHeader) + 1 ] )
            dbDelete( )
            
        endIf
        
    Else
        RecLock( "ZA3", .T.)
        
    EndIf

     If ! aCOLS [nI, Len ( aHeader ) + 1]
            ZA3->ZA3_FILIAL := xFilial ("ZA3")
            ZA3->ZA3_CODIGO := cCodigo
            ZA3->ZA3_DATA := dData
            
            for nI:= 1 to Len ( aHeader )
                    FieldPut ( FieldPos (  aHeader [ x, 2] ), aCOLS [ nI, nX] )
            	
            next nX
     		
     EndIf
    MsUnLock
    Next nI
    RestArea ( aArea ) 
        
Return
// Rotina para exclusao
Static Function Mod2GrvE ( )
   Local nI := 0 
   
   dbSelectArea ( "ZA3" ) 
   For nI:= 1  To Len (aCOLS ) 
        dbGotop(  aREG [ nI] )
        RecLock ( "ZA3", .F. ) 
        dbDelete ( )
        MsUnLock ( )
   
   Next nI
   
Return

//  funcao auxiliar para validacao


Static Function  Mod2Vend (cCodigo,  cNome )
    
            If ExistCpo( "SA3", cCodigo) .And. ExistChav ("ZA3", cCodigo)
                    cNome:= Posicione ("SA3", 1, xFilial ("SA3") + cCodigo, "A3_Nome")
            EndIf

Return ( ! Empty (cNome) )

User Function  Mod2LOk( )

    Local lRet := .T.
    Local cMensagem := "No sera permitido linhas sem centro de custo!"
            If  ! aCOLS [ n, Len ( aHeader ) + 1 ]
                    if Empty ( aCOLS  [ n, GdFieldPos ("ZA3_CUSTO") ] )
                            MsgAlert( cMensagem, cCadastro)
                            lRet := .F.                    	
                    endIf
                    
            EndIf

Return ( lRet )

User Function  Mod2TOk( )
    
    Local lRet := .T.
    Local nI := 0
    Local cMensagem := " "
    

Return 